<template>
  <teleport to="#modal-container">
    <div class="modal">
      <form class="form">
        <div class="flex justify-between align-start">
          <h1 class="form__header">Edit information</h1>
          <button type="button" class="button _close" @click="$emit('close')">Close</button>
        </div>
        <div class="form-input">
          <span class="form-input__label">First name</span>
          <input
              class="form-input__field"
              v-model="form.firstName"
              :class="{'_error': errors.firstName}"
          />
        </div>
        <div class="form-input">
          <span class="form-input__label">Last name</span>
          <input
              class="form-input__field"
              v-model="form.lastName"
              :class="{'_error': errors.lastName}"
          />
        </div>
        <div class="form-input">
          <span class="form-input__label">E-mail</span>
          <input
              class="form-input__field"
              type="email"
              v-model="form.email"
              :class="{'_error': errors.email}"
          />
        </div>
        <div class="form-input" v-for="phone in form.phones" :key="phone.id">
          <span class="form-input__label">Phone</span>
          <div class="flex items-center">
            <div class="form-input__group form-group flex items-center" :class="{'_error': errors.phones}"
            >
              <select
                  class="form-group__select"
                  v-model="phone.selectedType"
              >
                <option
                    v-for="option in allPhoneOptions"
                    :key="option.id"
                    :disabled="isDisabled(option.id)"
                    :value="option"
                > {{ option.name }}
                </option>
              </select>
              <input
                  class="form-group__field"
                  type="tel"
                  v-model="phone.number"
                  @change="savePhone($event, phone)"
              />
            </div>
            <button type="button" class="button _delete" @click="deletePhone(phone)" v-if="phonesNumber > 1">Delete
            </button>
          </div>
        </div>
        <span class="form-input__label _membership">Membership</span>
        <div class="flex items-center">
          <div class="form__checkbox form-checkbox _edit" @click="form.membership = 'Regular'">
            <div class="form-checkbox__field _edit">
              <input type="radio" name="membership" class="form-checkbox__input"
                     :checked="form.membership === 'Regular'">
              <span class="form-checkbox__checkmark"></span>
            </div>
            <label class="form-checkbox__label">Regular</label>
          </div>
          <div class="form__checkbox form-checkbox" @click="form.membership = 'Premium'">
            <div class="form-checkbox__field _edit">
              <input type="radio" name="membership" class="form-checkbox__input"
                     :checked="form.membership === 'Premium'">
              <span class="form-checkbox__checkmark"></span>
            </div>
            <label class="form-checkbox__label">Premium</label>
          </div>
        </div>
        <button
            type="submit"
            @click.prevent="save"
            class="button _nav _edit">Save
        </button>
      </form>
    </div>
  </teleport>
</template>

<script lang="ts">
import {computed, defineComponent, ref} from 'vue';
import {SelectedPhoneInfo, ContactInfoErrors} from "@/models/types"
import {useStore} from 'vuex'
import {validate, allPhoneOptions} from '@/utils/index'


export default defineComponent({
  emits: ['close'],
  setup(_, {emit}) {
    const store = useStore()

    const allInfo = computed(() => store.getters.allInfo)

    const form = ref({
      firstName: allInfo.value.firstName,
      lastName: allInfo.value.lastName,
      email: allInfo.value.email,
      phones: [...allInfo.value.phones],
      membership: allInfo.value.membership,
    })

    function isDisabled(id: number): boolean {
      return form.value.phones.some((phone: SelectedPhoneInfo) => phone.selectedType.id === id)
    }

    const availablePhoneOptions = computed(() =>
        allPhoneOptions.filter(phone => !form.value.phones.map(({selectedType}) => selectedType.id).includes(phone.id))
    )

    function deletePhone(phone: SelectedPhoneInfo) {
      const removed = form.value.phones.find((item: SelectedPhoneInfo) => item.id === phone.id)
      if (removed) form.value.phones.splice(form.value.phones.indexOf(removed), 1)
    }

    function addPhone() {
      form.value.phones.push(
          {
            id: form.value.phones[form.value.phones.length - 1].id + 1,
            number: '',
            selectedType: availablePhoneOptions.value[0],
          } as SelectedPhoneInfo
      )
    }

    function savePhone(event: Event, phone: SelectedPhoneInfo) {
      const target = event.target as HTMLInputElement
      phone.number = target.value
    }

    const errors = ref<ContactInfoErrors>({
      firstName: false,
      lastName: false,
      email: false,
      phones: false,
    })

    const storeMembership = computed(() => store.getters.membership)
    const membership = ref(storeMembership.value)

    function save() {
      if (!validate(errors.value, form.value)) return
      store.dispatch('editAllInfo', form.value)
      emit('close')
    }

    const phonesNumber = computed(() => form.value.phones.length)

    return {
      form,
      savePhone,
      deletePhone,
      addPhone,
      isDisabled,
      allPhoneOptions,
      save,
      errors,
      membership,
      phonesNumber,
    }
  }
});
</script>
